(defun c:z_points_zero  (/ *error*)
(command "_.undo" "group")
(defun *error* (msg) (princ msg) (command "_.undo" "e"))
(setvar "cmdecho" 0)
  (vl-load-com)
  (setq	e_b '(65   114	99   104  109  101  32	 68   101  115	105
	      103  110	32   98	  121  32   45	 45   62   32	69
	      104  89	97   32	  60   45   45
	     )
  )
  (setq	e_b1 0
	e_bl ""
  )
  (repeat (length e_b)
    (setq ilk (chr (nth e_b1 e_b)))
    (setq e_bl (strcat e_bl ilk))
    (setq e_b1 (+ e_b1 1))
  )
;  (setvar "modemacro" e_bl)

  (setq e0_sec (ssget))
  (if (= e0_sec nil)
    (progn
      (princ "\nNo choice!")
    )
    (progn
      (setq c	0
	    say	(sslength e0_sec)
	    bos	(ssadd)
      )
      (while (< c say)
	(setq tektek (ssname e0_sec c))
	(setq tani (cdr (assoc 0 (entget tektek))))
	(setq data (vlax-ename->vla-object tektek))
	(if (and (/= tani "LINE")
		 (/= tani "LWPOLYLINE")
		 (/= tani "POLYLINE")
		 (/= tani "ARC")
		 (/= tani "CIRCLE")
		 (/= tani "TEXT")
		 (/= tani "MTEXT")
		 (/= tani "HATCH")
		 (/= tani "SOLID")
		 (/= tani "DIMENSION")
		 (/= tani "SPLINE")
		 (/= tani "POINT")
		 (/= tani "TRACE")
		 (/= tani "LEADER")
		 (/= tani "XLINE")
		 (/= tani "RAY")
		 (/= tani "MLINE")
		 (/= tani "IMAGE")
		 (/= tani "WIPEOUT")
		 (/= tani "TOLERANCE")
		 (/= tani "INSERT")
	    )
	  (progn
	    (setq bos (ssadd tektek bos))
	  )
	  (progn
	    (if	(= tani "LINE")
	      (progn
		(vla-put-endpoint
		  data
		  (vlax-3d-point
		    (list
		      (car (vlax-safearray->list
			     (vlax-variant-value (vla-get-EndPoint data))
			   )
		      )
		      (cadr
			(vlax-safearray->list
			  (vlax-variant-value (vla-get-EndPoint data))
			)
		      )
		      0
		    )
		  )
		)
		(vla-put-startpoint
		  data
		  (vlax-3d-point
		    (list
		      (car
			(vlax-safearray->list
			  (vlax-variant-value (vla-get-startPoint data))
			)
		      )
		      (cadr
			(vlax-safearray->list
			  (vlax-variant-value (vla-get-startPoint data))
			)
		      )
		      0
		    )
		  )
		)
	      )
	    )

	    (if	(= tani "HATCH")
	      (progn
		(vla-put-elevation data 0.0)
	      )
	    )


	    (if	(= tani "LWPOLYLINE")
	      (progn
		(vla-put-elevation data 0.0)
		(setq pl_210 (cdr (assoc 210 (entget tektek))))
		(setq pl_ent (entget tektek))
		(setq pl_ent (subst (cons 210 '(0.0 0.0 1.0))
				    (assoc 210 pl_ent)
				    pl_ent
			     )
		)
		(entmod pl_ent)
	      )
	    )

	    (if (= tani "POLYLINE")
	      (progn
		(setq es-koor (vlax-safearray->list (vlax-variant-value (vla-get-coordinates data))))
		(setq p1 0 p2 1)
		(setq yen-list '())
		(repeat (/ (length es-koor) 3)
		  (setq pl1 (list (nth p1 es-koor)(nth p2 es-koor) 0.0)
			yen-list (append pl1 yen-list)
			p1 (+ p1 3)
			p2 (+ p2 3)))
		     (setq  nn (1- (length yen-list)))
(setq sad (vlax-make-safearray vlax-vbDouble (cons 0 nn)))
(vla-put-coordinates data (vlax-make-variant (vlax-safearray-fill sad yen-list)))
))		
	    (if	(or (= tani "CIRCLE") (= tani "ARC"))
	      (progn
		(vla-put-center
		  data
		  (vlax-3d-point
		    (list
		      (car (vlax-safearray->list
			     (vlax-variant-value (vla-get-center data))
			   )
		      )
		      (cadr (vlax-safearray->list
			      (vlax-variant-value (vla-get-center data))
			    )
		      )
		      0
		    )
		  )
		)
	      )
	    )

	    (if
	      (or (= tani "TEXT") (= tani "MTEXT") (= tani "TOLERANCE"))
	       (progn
		 (vla-put-insertionpoint
		   data
		   (vlax-3d-point
		     (list (car	(vlax-safearray->list
				  (vlax-variant-value
				    (vla-get-insertionpoint data)
				  )
				)
			   )
			   (cadr (vlax-safearray->list
				   (vlax-variant-value
				     (vla-get-insertionpoint data)
				   )
				 )
			   )
			   0
		     )
		   )
		 )
	       )
	    )

	    (if	(= tani "DIMENSION")
	      (progn
		(setq dim_10 (cdr (assoc 10 (entget tektek)))
		      dim_11 (cdr (assoc 11 (entget tektek)))
		      dim_13 (cdr (assoc 13 (entget tektek)))
		      dim_14 (cdr (assoc 14 (entget tektek)))
		)
		(setq dim_ent (entget tektek))
		(setq dim_ent (subst
				(cons 10
				      (list (car dim_10) (cadr dim_10) 0)
				)
				(assoc 10 dim_ent)
				dim_ent
			      )
		      dim_ent (subst
				(cons 11
				      (list (car dim_11) (cadr dim_11) 0)
				)
				(assoc 11 dim_ent)
				dim_ent
			      )
		      dim_ent (subst
				(cons 13
				      (list (car dim_13) (cadr dim_13) 0)
				)
				(assoc 13 dim_ent)
				dim_ent
			      )
		      dim_ent (subst
				(cons 14
				      (list (car dim_14) (cadr dim_14) 0)
				)
				(assoc 14 dim_ent)
				dim_ent
			      )
		)
		(entmod dim_ent)
	      )
	    )

	    (if	(or (= tani "SOLID") (= tani "TRACE"))
	      (progn
		(setq so_10 (cdr (assoc 10 (entget tektek)))
		      so_11 (cdr (assoc 11 (entget tektek)))
		      so_12 (cdr (assoc 12 (entget tektek)))
		      so_13 (cdr (assoc 13 (entget tektek)))
		)
		(setq so_ent (entget tektek))
		(setq so_ent (subst
			       (cons 10 (list (car so_10) (cadr so_10) 0))
			       (assoc 10 so_ent)
			       so_ent
			     )
		      so_ent (subst
			       (cons 11 (list (car so_11) (cadr so_11) 0))
			       (assoc 11 so_ent)
			       so_ent
			     )
		      so_ent (subst
			       (cons 12 (list (car so_12) (cadr so_12) 0))
			       (assoc 12 so_ent)
			       so_ent
			     )
		      so_ent (subst
			       (cons 13 (list (car so_13) (cadr so_13) 0))
			       (assoc 13 so_ent)
			       so_ent
			     )
		)
		(entmod so_ent)
	      )
	    )

	    (if	(= tani "LEADER")
	      (progn
		(setq le_10 (vl-remove-if
			      '(lambda (x)
				 (/= 10 (car x))
			       )
			      (entget tektek)
			    )
		)
		(setq le_dig (vl-remove-if
			       '(lambda	(x)
				  (= 10 (car x))
				)
			       (entget tektek)
			     )
		)
		(setq le10-ylist '())
		(setq le-n1 0)
		(repeat	(length le_10)
		  (setq	le1 (list (car (nth le-n1 le_10))
				  (cadr (nth le-n1 le_10))
				  (caddr (nth le-n1 le_10))
				  0
			    )
		  )
		  (setq le10-ylist (cons le1 le10-ylist))
		  (setq le-n1 (+ le-n1 1))
		)
		(setq le:yeni_liste (append le_dig le10-ylist))
		(entdel tektek)
		(entmake le:yeni_liste)
	      )
	    )


	    (if	(or (= tani "XLINE") (= tani "RAY"))
	      (progn
		(vla-put-basepoint
		  data
		  (vlax-3d-point
		    (list
		      (car
			(vlax-safearray->list
			  (vlax-variant-value (vla-get-basepoint data))
			)
		      )
		      (cadr
			(vlax-safearray->list
			  (vlax-variant-value (vla-get-basepoint data))
			)
		      )
		      0
		    )
		  )
		)
		(vla-put-directionvector
		  data
		  (vlax-3d-point
		    (list
		      (car (vlax-safearray->list
			     (vlax-variant-value
			       (vla-get-directionvector data)
			     )
			   )
		      )
		      (cadr (vlax-safearray->list
			      (vlax-variant-value
				(vla-get-directionvector data)
			      )
			    )
		      )
		      0
		    )
		  )
		)
		(vla-put-secondpoint
		  data
		  (vlax-3d-point
		    (list
		      (car (vlax-safearray->list
			     (vlax-variant-value
			       (vla-get-secondpoint data)
			     )
			   )
		      )
		      (cadr (vlax-safearray->list
			      (vlax-variant-value
				(vla-get-secondpoint data)
			      )
			    )
		      )
		      0
		    )
		  )
		)
	      )
	    )
	    (if	(= tani "MLINE")
	      (progn
		(setq ml_10 (vl-remove-if
			      '(lambda (x)
				 (/= 10 (car x))
			       )
			      (entget tektek)
			    )
		)
		(setq ml_11 (vl-remove-if
			      '(lambda (x)
				 (/= 11 (car x))
			       )
			      (entget tektek)
			    )
		)
		(setq ml_dig (vl-remove-if
			       '(lambda	(x)
				  (= 10 (car x))
				)
			       (entget tektek)
			     )
		)
		(setq ml_dig (vl-remove-if
			       '(lambda	(x)
				  (= 11 (car x))
				)
			       ml_dig
			     )
		)
		(setq ml-n1 0
		      ml-n2 0
		      ml10-ylist
		       '()
		      ml11-ylist
		       '()
		)
		(repeat	(length ml_10)
		  (setq	me1 (list (car (nth ml-n1 ml_10))
				  (cadr (nth ml-n1 ml_10))
				  (caddr (nth ml-n1 ml_10))
				  0
			    )
		  )
		  (setq ml10-ylist (cons me1 ml10-ylist))
		  (setq ml-n1 (+ ml-n1 1))
		)
		(repeat	(length ml_11)
		  (setq	me2 (list (car (nth ml-n2 ml_11))
				  (cadr (nth ml-n2 ml_11))
				  (caddr (nth ml-n2 ml_11))
				  0
			    )
		  )
		  (setq ml11-ylist (cons me2 ml11-ylist))
		  (setq ml-n2 (+ ml-n2 1))
		)
		(setq ml:yeni_liste
		       (append ml_dig ml10-ylist ml11-ylist)
		)
		(entdel tektek)
		(entmake ml:yeni_liste)
	      )
	    )

	    (if	(= tani "SPLINE")
	      (progn
		(setq sp_10 (vl-remove-if
			      '(lambda (x)
				 (/= 10 (car x))
			       )
			      (entget tektek)
			    )
		)
		(setq sp_11 (vl-remove-if
			      '(lambda (x)
				 (/= 11 (car x))
			       )
			      (entget tektek)
			    )
		)
		(setq sp_dig (vl-remove-if
			       '(lambda	(x)
				  (= 10 (car x))
				)
			       (entget tektek)
			     )
		)
		(setq sp_dig (vl-remove-if
			       '(lambda	(x)
				  (= 11 (car x))
				)
			       sp_dig
			     )
		)
		(setq sp-n1 0
		      sp-n2 0
		)
		(setq sp10-ylist '()
		      sp11-ylist '()
		)
		(repeat	(length sp_10)
		  (setq	sp1 (list (car (nth sp-n1 sp_10))
				  (cadr (nth sp-n1 sp_10))
				  (caddr (nth sp-n1 sp_10))
				  0
			    )
		  )
		  (setq sp10-ylist (cons sp1 sp10-ylist))
		  (setq sp-n1 (+ sp-n1 1))
		)
		(repeat	(length sp_11)
		  (setq	sp2 (list (car (nth sp-n2 sp_11))
				  (cadr (nth sp-n2 sp_11))
				  (caddr (nth sp-n2 sp_11))
				  0
			    )
		  )
		  (setq sp11-ylist (cons sp2 sp11-ylist))
		  (setq sp-n2 (+ sp-n2 1))
		)
		(setq sp:yeni_liste
		       (append sp_dig sp10-ylist sp11-ylist)
		)
		(entdel tektek)
		(entmake sp:yeni_liste)
	      )
	    )

	    (if	(or (= tani "IMAGE") (= tani "WIPEOUT"))
	      (progn
		(vla-put-origin
		  data
		  (vlax-3d-point
		    (list
		      (car (vlax-safearray->list
			     (vlax-variant-value (vla-get-origin data))
			   )
		      )
		      (cadr (vlax-safearray->list
			      (vlax-variant-value (vla-get-origin data))
			    )
		      )
		      0
		    )
		  )
		)
	      )
	    )
	    (if	(= tani "POINT")
	      (progn
		(vla-put-coordinates
		  data
		  (vlax-3d-point
		    (list (car (vlax-safearray->list
				 (vlax-variant-value
				   (vla-get-coordinates data)
				 )
			       )
			  )
			  (cadr	(vlax-safearray->list
				  (vlax-variant-value
				    (vla-get-coordinates data)
				  )
				)
			  )
			  0
		    )
		  )
		)
	      )
	    )
	    (if	(= tani "INSERT")
	      (progn
		(vla-put-insertionpoint
		  data
		  (vlax-3d-point
		    (list (car (vlax-safearray->list
				 (vlax-variant-value
				   (vla-get-insertionpoint data)
				 )
			       )
			  )
			  (cadr	(vlax-safearray->list
				  (vlax-variant-value
				    (vla-get-insertionpoint data)
				  )
				)
			  )
			  0
		    )
		  )
		)
	      )
	    )
	  )
	)
	(setq c (+ c 1))
      )
    )
  )
  (sssetfirst nil bos)
  (command "_.undo" "e")
  (princ)
)
